diff --git a/src/vehicle_gui.cpp b/src/vehicle_gui.cpp
--- a/src/vehicle_gui.cpp
+++ b/src/vehicle_gui.cpp
@@ -39,6 +39,8 @@
 #include "engine_func.h"
 #include "station_base.h"
 #include "tilehighlight_func.h"
+#include "infrastructure_func.h"
+#include "train.h"
 
 #include "table/strings.h"
 
@@ -277,6 +279,31 @@
 	return ret_refit_cyc;
 }
 
+/**
+ * Get the engine that suffers from the most severe breakdown.
+ * This means the engine with the lowest breakdown_type.
+ * If the breakdown types of 2 engines are equal, the one with the lowest breakdown_severity (most severe) is picked.
+ * @param v  Front engine of the train.
+ * @return w The most severly broken engine.
+ */
+const Vehicle *GetMostSeverelyBrokenEngine(const Train *v)
+{
+	assert(v->IsFrontEngine());
+	const Vehicle *w = v;
+	byte most_severe_type = 255;
+	for (const Vehicle *u = v; u != NULL; u = u->Next()) {
+		if (u->breakdown_ctr == 1) {
+			if (u->breakdown_type < most_severe_type) {
+				most_severe_type = u->breakdown_type;
+				w = u;
+			} else if (u->breakdown_type == most_severe_type && u->breakdown_severity < w->breakdown_severity) {
+				w = u;
+			}
+		}
+	}
+	return w;
+}
+
 /** Option to refit a vehicle chain */
 struct RefitOption {
 	CargoID cargo;    ///< Cargo to refit to
@@ -351,6 +378,9 @@
 /** Widget numbers of the vehicle refit window. */
 enum VehicleRefitWidgets {
 	VRW_CAPTION,
+	VRW_SHOW_VEHICLEHEADER,
+	VRW_VEHICLEHEADER,
+	VRW_VEHICLE_SELECT_ALL,
 	VRW_VEHICLE_PANEL_DISPLAY,
 	VRW_SHOW_HSCROLLBAR,
 	VRW_HSCROLLBAR,
@@ -506,6 +536,7 @@
 		nwi->tool_tip    = STR_REFIT_TRAIN_REFIT_TOOLTIP + v->type;
 		this->GetWidget<NWidgetStacked>(VRW_SHOW_HSCROLLBAR)->SetDisplayedPlane(v->IsGroundVehicle() ? 0 : SZSP_HORIZONTAL);
 		this->GetWidget<NWidgetCore>(VRW_VEHICLE_PANEL_DISPLAY)->tool_tip = (v->type == VEH_TRAIN) ? STR_REFIT_SELECT_VEHICLES_TOOLTIP : STR_NULL;
+		this->GetWidget<NWidgetStacked>(VRW_SHOW_VEHICLEHEADER)->SetDisplayedPlane(v->type == VEH_TRAIN ? 0 : SZSP_HORIZONTAL);
 
 		this->FinishInitNested(desc, v->index);
 		this->owner = v->owner;
@@ -811,6 +842,15 @@
 	virtual void OnClick(Point pt, int widget, int click_count)
 	{
 		switch (widget) {
+			case VRW_VEHICLE_SELECT_ALL: {
+				/* Clear the selection. */
+				Vehicle *v = Vehicle::Get(this->window_number);
+				this->selected_vehicle = v->index;
+				this->num_vehicles = UINT8_MAX;
+				this->SetWidgetDirty(VRW_VEHICLE_PANEL_DISPLAY);
+				break;
+			}
+
 			case VRW_VEHICLE_PANEL_DISPLAY: { // Vehicle image.
 				if (this->order != INVALID_VEH_ORDER_ID) break;
 				NWidgetBase *nwi = this->GetWidget<NWidgetBase>(VRW_VEHICLE_PANEL_DISPLAY);
@@ -891,6 +931,12 @@
 		NWidget(WWT_CLOSEBOX, COLOUR_GREY),
 		NWidget(WWT_CAPTION, COLOUR_GREY, VRW_CAPTION), SetDataTip(STR_REFIT_CAPTION, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
 	EndContainer(),
+	NWidget(NWID_SELECTION, INVALID_COLOUR, VRW_SHOW_VEHICLEHEADER),
+		NWidget(NWID_HORIZONTAL),
+			NWidget(WWT_TEXTBTN, COLOUR_GREY, VRW_VEHICLEHEADER), SetDataTip(STR_REFIT_VEHICLE_SELECTION_TITLE, STR_NULL), SetFill(1, 0), SetResize(1, 0),
+			NWidget(WWT_PUSHTXTBTN, COLOUR_GREY, VRW_VEHICLE_SELECT_ALL), SetDataTip(STR_REFIT_VEHICLE_SELECT_ALL, STR_REFIT_VEHICLE_SELECT_ALL_TOOLTIP),
+		EndContainer(),
+	EndContainer(),
 	/* Vehicle display + scrollbar. */
 	NWidget(NWID_VERTICAL),
 		NWidget(WWT_PANEL, COLOUR_GREY, VRW_VEHICLE_PANEL_DISPLAY), SetMinimalSize(228, 14), SetResize(1, 0), SetScrollbar(VRW_HSCROLLBAR), EndContainer(),
@@ -1246,7 +1292,7 @@
 	} while (oid != start);
 }
 
-/**
+ /**
  * Draws an image of a vehicle chain
  * @param v         Front vehicle
  * @param left      The minimum horizontal position
@@ -2000,8 +2046,25 @@
 				y += FONT_HEIGHT_NORMAL;
 
 				/* Draw breakdown & reliability */
-				SetDParam(0, ToPercent16(v->reliability));
-				SetDParam(1, v->breakdowns_since_last_service);
+				byte total_engines = 0;
+				if (v->type == VEH_TRAIN) {
+					/* We want to draw the average reliability and total number of breakdowns. */
+					uint32 total_reliability = 0;
+					uint16 total_breakdowns  = 0;
+					for (const Vehicle *w = v; w != NULL; w = w->Next()) {
+						if (Train::From(w)->IsEngine() || Train::From(w)->IsMultiheaded()) {
+							total_reliability += w->reliability;
+							total_breakdowns += w->breakdowns_since_last_service;
+						}
+					}
+					total_engines = Train::From(v)->tcache.cached_num_engines;
+					assert(total_engines > 0);
+					SetDParam(0, ToPercent16(total_reliability / total_engines));
+					SetDParam(1, total_breakdowns);
+				} else {
+					SetDParam(0, ToPercent16(v->reliability));
+					SetDParam(1, v->breakdowns_since_last_service);
+				}
 				DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_RIGHT, y, STR_VEHICLE_INFO_RELIABILITY_BREAKDOWNS);
 				break;
 			}
@@ -2288,6 +2351,13 @@
 	DoCommandP(v->tile, v->index, 0, _vehicle_command_translation_table[VCT_CMD_START_STOP][v->type], texteffect ? CcStartStopVehicle : NULL);
 }
 
+/** Strings for aircraft breakdown types. */
+static const StringID _aircraft_breakdown_strings[] = {
+	STR_BREAKDOWN_TYPE_LOW_SPEED,
+	STR_BREAKDOWN_TYPE_DEPOT,
+	STR_BREAKDOWN_TYPE_LANDING,
+};
+
 /** Checks whether the vehicle may be refitted at the moment.*/
 static bool IsVehicleRefitable(const Vehicle *v)
 {
@@ -2419,6 +2489,7 @@
 	{
 		const Vehicle *v = Vehicle::Get(this->window_number);
 		bool is_localcompany = v->owner == _local_company;
+		bool can_control = IsVehicleControlAllowed(v, _local_company);
 		bool refitable_and_stopped_in_depot = IsVehicleRefitable(v);
 
 		this->SetWidgetDisabledState(VVW_WIDGET_GOTO_DEPOT, !is_localcompany);
@@ -2427,8 +2498,8 @@
 
 		if (v->type == VEH_TRAIN) {
 			this->SetWidgetLoweredState(VVW_WIDGET_FORCE_PROCEED, Train::From(v)->force_proceed == TFP_SIGNAL);
-			this->SetWidgetDisabledState(VVW_WIDGET_FORCE_PROCEED, !is_localcompany);
-			this->SetWidgetDisabledState(VVW_WIDGET_TURN_AROUND, !is_localcompany);
+			this->SetWidgetDisabledState(VVW_WIDGET_FORCE_PROCEED, !can_control);
+			this->SetWidgetDisabledState(VVW_WIDGET_TURN_AROUND, !can_control);
 		}
 
 		this->DrawWidgets();
@@ -2450,8 +2521,31 @@
 		StringID str;
 		if (v->vehstatus & VS_CRASHED) {
 			str = STR_VEHICLE_STATUS_CRASHED;
-		} else if (v->type != VEH_AIRCRAFT && v->breakdown_ctr == 1) { // check for aircraft necessary?
-			str = STR_VEHICLE_STATUS_BROKEN_DOWN;
+		} else if (v->breakdown_ctr == 1 || (v->type == VEH_TRAIN && Train::From(v)->flags & VRF_IS_BROKEN)) {
+			if (_settings_game.vehicle.improved_breakdowns) {
+				str = STR_VEHICLE_STATUS_BROKEN_DOWN_VEL;
+				SetDParam(2, v->GetDisplaySpeed());
+			} else {
+				str = STR_VEHICLE_STATUS_BROKEN_DOWN;
+			}
+
+			if (v->type == VEH_AIRCRAFT) {
+				SetDParam(0, _aircraft_breakdown_strings[v->breakdown_type]);
+				if (v->breakdown_type == BREAKDOWN_AIRCRAFT_SPEED) {
+					SetDParam(1, v->breakdown_severity << 3);
+				} else {
+					SetDParam(1, v->current_order.GetDestination());
+				}
+			} else {
+				const Vehicle *w = (v->type == VEH_TRAIN) ? GetMostSeverelyBrokenEngine(Train::From(v)) : v;
+				SetDParam(0, STR_BREAKDOWN_TYPE_CRITICAL + w->breakdown_type);
+
+				if (w->breakdown_type == BREAKDOWN_LOW_SPEED) {
+					SetDParam(1, min( w->First()->GetDisplayMaxSpeed(), w->breakdown_severity >> (v->type == VEH_TRAIN ? 0 : 1 )));
+				} else if (w->breakdown_type == BREAKDOWN_LOW_POWER) {
+					SetDParam(1, w->breakdown_severity * 100 / 256);
+				}
+			}
 		} else if (v->vehstatus & VS_STOPPED) {
 			if (v->type == VEH_TRAIN) {
 				if (v->cur_speed == 0) {
@@ -2462,7 +2556,7 @@
 					}
 				} else {
 					SetDParam(0, v->GetDisplaySpeed());
-					str = STR_VEHICLE_STATUS_TRAIN_STOPPING_VEL;
+					str = STR_VEHICLE_STATUS_TRAIN_STOPPING + _settings_client.gui.vehicle_speed;
 				}
 			} else { // no train
 				str = STR_VEHICLE_STATUS_STOPPED;
@@ -2474,7 +2568,7 @@
 				case OT_GOTO_STATION: {
 					SetDParam(0, v->current_order.GetDestination());
 					SetDParam(1, v->GetDisplaySpeed());
-					str = STR_VEHICLE_STATUS_HEADING_FOR_STATION_VEL;
+					str = STR_VEHICLE_STATUS_HEADING_FOR_STATION + _settings_client.gui.vehicle_speed;
 					break;
 				}
 
@@ -2491,9 +2585,9 @@
 						 * evaluating the string in the status bar. */
 						str = STR_EMPTY;
 					} else if (v->current_order.GetDepotActionType() & ODATFB_HALT) {
-						str = STR_VEHICLE_STATUS_HEADING_FOR_DEPOT_VEL;
+						str = STR_VEHICLE_STATUS_HEADING_FOR_DEPOT + _settings_client.gui.vehicle_speed;
 					} else {
-						str = STR_VEHICLE_STATUS_HEADING_FOR_DEPOT_SERVICE_VEL;
+						str = STR_VEHICLE_STATUS_HEADING_FOR_DEPOT_SERVICE + _settings_client.gui.vehicle_speed;
 					}
 					break;
 				}
@@ -2505,7 +2599,7 @@
 				case OT_GOTO_WAYPOINT: {
 					assert(v->type == VEH_TRAIN || v->type == VEH_SHIP);
 					SetDParam(0, v->current_order.GetDestination());
-					str = STR_VEHICLE_STATUS_HEADING_FOR_WAYPOINT_VEL;
+					str = STR_VEHICLE_STATUS_HEADING_FOR_WAYPOINT + _settings_client.gui.vehicle_speed;
 					SetDParam(1, v->GetDisplaySpeed());
 					break;
 				}
@@ -2519,7 +2613,7 @@
 
 				default:
 					if (v->GetNumManualOrders() == 0) {
-						str = STR_VEHICLE_STATUS_NO_ORDERS_VEL;
+						str = STR_VEHICLE_STATUS_NO_ORDERS + _settings_client.gui.vehicle_speed;
 						SetDParam(0, v->GetDisplaySpeed());
 					} else {
 						str = STR_EMPTY;
diff --git a/src/vehicle_type.h b/src/vehicle_type.h
--- a/src/vehicle_type.h
+++ b/src/vehicle_type.h
@@ -72,7 +72,19 @@
 	DEPOT_COMMAND_MASK  = 0xFU << 28,
 };
 
-static const uint MAX_LENGTH_VEHICLE_NAME_CHARS = 32; ///< The maximum length of a vehicle name in characters including '\0'
+static const uint MAX_LENGTH_VEHICLE_NAME_CHARS  =  32; ///< The maximum length of a vehicle name in characters including '\0'
+
+/* The different types of breakdowns. */
+enum BreakdownType {
+	BREAKDOWN_CRITICAL  = 0,                             ///< Old style breakdown (black smoke).
+	BREAKDOWN_EM_STOP   = 1,                             ///< Emergency stop.
+	BREAKDOWN_LOW_SPEED = 2,                             ///< Lower max speed.
+	BREAKDOWN_LOW_POWER = 3,                             ///< Power reduction.
+	/* Aircraft have totally different breakdowns, so we use aliases to make things clearer. */
+	BREAKDOWN_AIRCRAFT_SPEED      = BREAKDOWN_CRITICAL,  ///< Lower speed until the next airport.
+	BREAKDOWN_AIRCRAFT_DEPOT      = BREAKDOWN_EM_STOP,   ///< We have to visit a depot at the next airport.
+	BREAKDOWN_AIRCRAFT_EM_LANDING = BREAKDOWN_LOW_SPEED, ///< Emergency landing at the closest airport (with hangar!) we can find.
+};
 
 /** The length of a vehicle in tile units. */
 static const uint VEHICLE_LENGTH = 8;
diff --git a/src/viewport.cpp b/src/viewport.cpp
--- a/src/viewport.cpp
+++ b/src/viewport.cpp
@@ -41,13 +41,20 @@
 #include "zoom_func.h"
 #include "vehicle_func.h"
 #include "company_func.h"
+#include "core/alloc_func.hpp"
+#include "core/alloc_type.hpp"
+#include "core/smallvec_type.hpp"
 #include "waypoint_func.h"
 #include "window_func.h"
 #include "tilehighlight_func.h"
 #include "window_gui.h"
+#include "slope_func.h"
+#include "copy_paste.h"
 
 #include "table/strings.h"
 
+#include <map>
+
 Point _tile_fract_coords;
 
 struct StringSpriteToDraw {
@@ -92,8 +99,8 @@
 	int32 xmax;                     ///< maximal world X coordinate of bounding box
 	int32 ymin;                     ///< minimal world Y coordinate of bounding box
 	int32 ymax;                     ///< maximal world Y coordinate of bounding box
-	int zmin;                       ///< minimal world Z coordinate of bounding box
-	int zmax;                       ///< maximal world Z coordinate of bounding box
+	int zmin;                     ///< minimal world Z coordinate of bounding box
+	int zmax;                     ///< maximal world Z coordinate of bounding box
 
 	int first_child;                ///< the first child to draw.
 	bool comparison_done;           ///< Used during sprite sorting: true if sprite has been compared with all other sprites
@@ -385,9 +392,9 @@
 
 	/* we need to move variables in to the valid range, as the
 	 * GetTileZoomCenterWindow() function can call here with invalid x and/or y,
-	 * when the user tries to zoom out along the sides of the map */
-	a = Clamp(a, -4 * (int)TILE_SIZE, (int)(MapMaxX() * TILE_SIZE) - 1);
-	b = Clamp(b, -4 * (int)TILE_SIZE, (int)(MapMaxY() * TILE_SIZE) - 1);
+	 * when the user tries to zoom out along the sides of the map. */
+	a = Clamp(a, ((uint)GetMaxTileHeight() + 1) / 4 * -(int)TILE_SIZE, (int)(MapMaxX() * TILE_SIZE) - 1);
+	b = Clamp(b, ((uint)GetMaxTileHeight() + 1) / 4 * -(int)TILE_SIZE, (int)(MapMaxY() * TILE_SIZE) - 1);
 
 	/* (a, b) is the X/Y-world coordinate that belongs to (x,y) if the landscape would be completely flat on height 0.
 	 * Now find the Z-world coordinate by fix point iteration.
@@ -478,7 +485,7 @@
  * @param extra_offs_x Pixel X offset for the sprite position.
  * @param extra_offs_y Pixel Y offset for the sprite position.
  */
-static void AddTileSpriteToDraw(SpriteID image, PaletteID pal, int32 x, int32 y, int z, const SubSprite *sub = NULL, int extra_offs_x = 0, int extra_offs_y = 0)
+static void AddTileSpriteToDraw(SpriteID image, PaletteID pal, int32 x, int32 y, int32 z, const SubSprite *sub = NULL, int extra_offs_x = 0, int extra_offs_y = 0)
 {
 	assert((image & SPRITE_MASK) < MAX_SPRITES);
 
@@ -891,6 +898,12 @@
 	DrawSelectionSprite(sel, pal, ti, 7, FOUNDATION_PART_NORMAL);
 }
 
+static void DrawPreviewSprite(SpriteID image, SpriteID pal, uint x, uint y, uint z)
+{
+	//DrawGroundSpriteAt(image, x, y, z + 7);
+	AddSortableSpriteToDraw(image, pal, x, y, 0x10, 0x10, 1, z + 7);
+}
+
 static bool IsPartOfAutoLine(int px, int py)
 {
 	px -= _thd.selstart.x;
@@ -922,6 +935,50 @@
 
 #include "table/autorail.h"
 
+/*
+static uint GetTileHFromCopyBuffer(TileIndex index, uint32 baseh, uint32* h)
+{
+	return GetTileh((uint)_copy_heightmap[index] + baseh, (uint)_copy_heightmap[index+1] + baseh, (uint)_copy_heightmap[index + _copy_width] + baseh, (uint)_copy_heightmap[index + _copy_width + 1] + baseh, h);
+}
+*/
+
+static void DrawPreviewTile(const TileInfo *ti)
+{
+	uint32 image;
+	//We have to get the index within our _copy_paste.m_rail[] structure
+	uint32 tile_x = ti->x / TILE_SIZE;
+	uint32 tile_y = ti->y / TILE_SIZE;
+	uint32 pos_x = _thd.pos.x / TILE_SIZE;
+	uint32 pos_y = _thd.pos.y / TILE_SIZE;
+	uint32 bindex = (tile_x - pos_x) + ((_copy_paste.GetWidth() - 1) * (tile_y - pos_y));
+	//uint32 baseh = TileHeight(TileXY(pos_x, pos_y));
+	//uint32 tindex = (tile_x - pos_x) + ((_copy_width) * (tile_y - pos_y));
+	//uint32 minh;
+	//uint32 tileh = GetTileHFromCopyBuffer(tindex, baseh, &minh);
+	
+	if (((tile_x - pos_x) == 0) || ((tile_x - pos_x) == (_copy_paste.GetWidth() - 2)) || ((tile_y - pos_y) == 0) || ((tile_y - pos_y) == (_copy_paste.GetHeight() - 2))) {
+		//Highlight BorderTiles
+		image = SPR_SELECT_TILE + SlopeToSpriteOffset(ti->tileh);
+		DrawPreviewSprite(image, PAL_NONE, ti->x, ti->y, ti->z);
+	}
+	
+	image = SPR_AUTORAIL_BASE;
+	TrackBits tracktodraw = _copy_paste.GetCPTrackBits(bindex);
+	for (Track t = TRACK_BEGIN; t < TRACK_END; t++) {
+		if (tracktodraw & TrackToTrackBits(t)) DrawPreviewSprite(image + _AutorailTilehSprite[SLOPE_FLAT][t], PAL_NONE, ti->x, ti->y, ti->z);
+	}
+	
+	/*
+	if ((_copy_rail[bindex] & (1U << TRACK_X))>0) DrawPreviewSprite(image, ti->x, ti->y, minh);
+	if ((_copy_rail[bindex] & (1U << TRACK_Y))>0) DrawPreviewSprite(image + 8, ti->x, ti->y, minh);
+	if ((_copy_rail[bindex] & (1U << TRACK_UPPER))>0) DrawPreviewSprite(image + 16, ti->x, ti->y, minh);
+	if ((_copy_rail[bindex] & (1U << TRACK_LOWER))>0) DrawPreviewSprite(image + 25, ti->x, ti->y, minh);
+	if ((_copy_rail[bindex] & (1U << TRACK_LEFT))>0) DrawPreviewSprite(image + 34, ti->x, ti->y, minh);
+	if ((_copy_rail[bindex] & (1U << TRACK_RIGHT))>0) DrawPreviewSprite(image + 42, ti->x, ti->y, minh);
+	
+	*/
+}
+
 /**
  * Draws autorail highlights.
  *
@@ -1004,6 +1061,8 @@
 			HighLightStyle type = _thd.drawstyle & HT_DIR_MASK;
 			assert(type < HT_DIR_END);
 			DrawAutorailSelection(ti, _autorail_type[type][0]);
+		} else if (_thd.drawstyle & HT_PREVIEW) {
+			DrawPreviewTile(ti);
 		} else if (IsPartOfAutoLine(ti->x, ti->y)) {
 			/* autorail highlighting long line */
 			HighLightStyle dir = _thd.drawstyle & HT_DIR_MASK;
@@ -1167,8 +1226,7 @@
 	const Town *t;
 	FOR_ALL_TOWNS(t) {
 		ViewportAddString(dpi, ZOOM_LVL_OUT_4X, &t->sign,
-				_settings_client.gui.population_in_label ? STR_VIEWPORT_TOWN_POP : STR_VIEWPORT_TOWN,
-				STR_VIEWPORT_TOWN_TINY_WHITE, STR_VIEWPORT_TOWN_TINY_BLACK,
+				t->Label(), t->SmallLabel(), STR_VIEWPORT_TOWN_TINY_BLACK,
 				t->index, t->population);
 	}
 }
@@ -1528,6 +1586,20 @@
 	dpi->top -= this->top;
 }
 
+/**
+ * How far should I allow scrolling outside the map?
+ *
+ * @see ClampViewportToMap()
+ */
+uint16 GetMaxScrollOutsideMap() {
+	/* Allow scrolling to high peaks at the NE/NW border if AllowMoreHeightlevels is true. */
+	if (AllowMoreHeightlevels()) {
+		return MAXSCROLL_NEW;
+	} else {
+		return MAXSCROLL_OLD;
+	}
+}
+
 static inline void ClampViewportToMap(const ViewPort *vp, int &x, int &y)
 {
 	/* Centre of the viewport is hot spot */
@@ -1539,9 +1611,9 @@
 	int vx = -x + y * 2;
 	int vy =  x + y * 2;
 
-	/* clamp to size of map */
-	vx = Clamp(vx, 0, MapMaxX() * TILE_SIZE * 4);
-	vy = Clamp(vy, 0, MapMaxY() * TILE_SIZE * 4);
+	/* Clamp to size of map. */
+	vx = Clamp(vx, - (uint16)GetMaxScrollOutsideMap(), MapMaxX() * TILE_SIZE * 4);
+	vy = Clamp(vy, - (uint16)GetMaxScrollOutsideMap(), MapMaxY() * TILE_SIZE * 4);
 
 	/* Convert map coordinates to viewport coordinates */
 	x = (-vx + vy) / 2;
@@ -1661,6 +1733,20 @@
 	);
 }
 
+void MarkTileDirtyByTileOutsideMap(int x, int y)
+{
+	Point pt = RemapCoords(x * TILE_SIZE, y * TILE_SIZE, GetTileZOutsideMap(x, y));
+	/* Since tiles painted outside the map don't contain buildings, trees, etc.,
+	 * this reduced area for repainting should suffice. If not, adjust the offsets
+	 * used below. */
+	MarkAllViewportsDirty(
+		pt.x - TILE_SIZE + 1,
+		pt.y,
+		pt.x + TILE_SIZE - 1,
+		pt.y + TILE_SIZE + TILE_HEIGHT - 1
+	);
+}
+
 /**
  * Marks the selected tiles as dirty.
  *
@@ -2139,6 +2225,9 @@
 					_thd.selstart.x = x1 & ~TILE_UNIT_MASK;
 					_thd.selstart.y = y1 & ~TILE_UNIT_MASK;
 					break;
+				case HT_PREVIEW:
+					new_drawstyle = HT_PREVIEW & HT_DRAG_MASK;
+					break;
 				default:
 					NOT_REACHED();
 					break;
@@ -2809,6 +2898,39 @@
 			}
 			break;
 
+		case VPM_A_B_LINE: { // drag an A to B line
+			TileIndex t0 = TileVirtXY(sx, sy);
+			TileIndex t1 = TileVirtXY(x, y);
+			uint dx = Delta(TileX(t0), TileX(t1)) + 1;
+			uint dy = Delta(TileY(t0), TileY(t1)) + 1;
+			byte index = 0;
+			uint64 params[5];
+
+			/* If dragging an area (eg dynamite tool) and it is actually a single
+			 * row/column, change the type to 'line' to get proper calculation for height */
+			style = (HighLightStyle)_thd.next_drawstyle;
+			if (style & HT_RECT) {
+				if (dx == 1) {
+					style = HT_LINE | HT_DIR_Y;
+				} else if (dy == 1) {
+					style = HT_LINE | HT_DIR_X;
+				}
+			}
+
+			if (dx != 1 || dy != 1) {
+				int heightdiff = CalcHeightdiff(style, 0, t0, t1);
+
+				params[index++] = DistanceManhattan(t0, t1);
+				params[index++] = sqrtl(dx * dx + dy * dy); //DistanceSquare does not like big numbers
+				params[index++] = DistanceFromEdge(t1);
+				params[index++] = GetTileMaxZ(t1) / TILE_HEIGHT * TILE_HEIGHT_STEP;
+				if (heightdiff != 0) params[index++] = heightdiff;
+			}
+			/* Show always the measurement tooltip */
+			GuiShowTooltips(_thd.GetCallbackWnd(), STR_MEASURE_DIST_HEIGHTDIFF, index, params);
+		break;
+ 		}
+
 		default: NOT_REACHED();
 	}
 
diff --git a/src/viewport_func.h b/src/viewport_func.h
--- a/src/viewport_func.h
+++ b/src/viewport_func.h
@@ -19,6 +19,27 @@
 
 static const int TILE_HEIGHT_STEP = 50; ///< One Z unit tile height difference is displayed as 50m.
 
+/**
+ * Indexed by GetMaxScrollOutsideMap()
+ *
+ * Considering,when increasing height at tile (1, 1)
+ * the first overlapping tile on tile(1, 1, 0) is tile(4, 4, 1),
+ * or the first tile completely drawn outside the map(no height) is tile(1, 1, 4),
+ * value below has been calculated as follows:
+ *
+ * extra_pixels_needed_for heightlevels = (max_possible_height / overlap * TILE_SIZE / 2)
+ * eg. 256 / 4 * 8 / 2 = 256 pixels for tile(1, 1, 255) to be inside viewport when fully zoomed in 
+ * 22 pixels for the toolbar.
+ * 150 pixels to be safe with tall buildings on tile(1, 1, 255).
+ *
+ * @note Subtract 8 for each pixel needed.
+ * @note Tuned for heightlevel 255.
+ */
+enum  ScrollMaxOutsideMap {
+MAXSCROLL_OLD  = 0,    ///< Before MoreHeightLevels
+MAXSCROLL_NEW  = 3424, ///< tile(1, 1) having height 255
+};
+
 void SetSelectionRed(bool);
 
 void DeleteWindowViewport(Window *w);
@@ -53,7 +74,6 @@
 void AddChildSpriteScreen(SpriteID image, PaletteID pal, int x, int y, bool transparent = false, const SubSprite *sub = NULL);
 void ViewportAddString(const DrawPixelInfo *dpi, ZoomLevel small_from, const ViewportSign *sign, StringID string_normal, StringID string_small, StringID string_small_shadow, uint64 params_1, uint64 params_2 = 0, Colours colour = INVALID_COLOUR);
 
-
 void StartSpriteCombine();
 void EndSpriteCombine();
 
@@ -66,6 +86,7 @@
 
 bool ScrollWindowToTile(TileIndex tile, Window *w, bool instant = false);
 bool ScrollWindowTo(int x, int y, int z, Window *w, bool instant = false);
+uint16 GetMaxScrollOutsideMap();
 
 bool ScrollMainWindowToTile(TileIndex tile, bool instant = false);
 bool ScrollMainWindowTo(int x, int y, int z = -1, bool instant = false);
@@ -75,5 +96,8 @@
 extern Point _tile_fract_coords;
 
 void MarkTileDirtyByTile(TileIndex tile);
+void MarkTileDirtyByTileOutsideMap(int x, int y);
+
+int GetRowAtTile(int viewport_y, Point tile);
 
 #endif /* VIEWPORT_FUNC_H */
diff --git a/src/viewport_type.h b/src/viewport_type.h
--- a/src/viewport_type.h
+++ b/src/viewport_type.h
@@ -14,6 +14,7 @@
 
 #include "zoom_type.h"
 #include "strings_type.h"
+#include "math.h"
 
 /**
  * Data structure for viewport, display of a part of the world
@@ -81,6 +82,7 @@
 	VPM_FIX_VERTICAL    =    6, ///< drag only in vertical direction
 	VPM_X_LIMITED       =    7, ///< Drag only in X axis with limited size
 	VPM_Y_LIMITED       =    8, ///< Drag only in Y axis with limited size
+	VPM_A_B_LINE        =    9, ///< Drag a line from tile A to tile B
 	VPM_RAILDIRS        = 0x40, ///< all rail directions
 	VPM_SIGNALDIRS      = 0x80, ///< similiar to VMP_RAILDIRS, but with different cursor
 };
@@ -101,6 +103,8 @@
 	DDSP_CREATE_RIVER,         ///< Create rivers
 	DDSP_PLANT_TREES,          ///< Plant trees
 	DDSP_BUILD_BRIDGE,         ///< Bridge placement
+	DDSP_COPY_AREA,            ///< Copy & paste
+	DDSP_MEASURE,              ///< Measurement tool // TODO: fix selecting 1 tile and reset values on mouse release.
 
 	/* Rail specific actions */
 	DDSP_PLACE_RAIL,           ///< Rail placement
diff --git a/src/void_cmd.cpp b/src/void_cmd.cpp
--- a/src/void_cmd.cpp
+++ b/src/void_cmd.cpp
@@ -13,13 +13,14 @@
 #include "tile_cmd.h"
 #include "command_func.h"
 #include "viewport_func.h"
+#include "slope_func.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
 
 static void DrawTile_Void(TileInfo *ti)
 {
-	DrawGroundSprite(SPR_SHADOW_CELL, PAL_NONE);
+	DrawGroundSprite(SPR_FLAT_BLACKTILES + SlopeToSpriteOffset(ti->tileh), PAL_NONE);
 }
 
 
@@ -35,7 +36,8 @@
 
 static CommandCost ClearTile_Void(TileIndex tile, DoCommandFlag flags)
 {
-	return_cmd_error(STR_ERROR_OFF_EDGE_OF_MAP);
+	CommandCost cost(EXPENSES_CONSTRUCTION);
+	return cost;
 }
 
 
@@ -62,7 +64,8 @@
 
 static CommandCost TerraformTile_Void(TileIndex tile, DoCommandFlag flags, int z_new, Slope tileh_new)
 {
-	return_cmd_error(STR_ERROR_OFF_EDGE_OF_MAP);
+	CommandCost cost(EXPENSES_CONSTRUCTION);
+	return cost;
 }
 
 extern const TileTypeProcs _tile_type_void_procs = {
